<?php
	
/**
 * 
 * This script evenly distribute images under the images folder based on their modification date.
 */

if ($_GET['hash'] != 'secrethash__')
	die();

if (version_compare(PHP_VERSION, '5.3.10', '<'))
{
	die('Your host needs to use PHP 5.3.10 or higher to run this version of Joomla!');
}

define('_JEXEC', 1);

if (file_exists(__DIR__ . '/defines.php'))
{
	include_once __DIR__ . '/defines.php';
}

if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', __DIR__);
	require_once JPATH_BASE . '/includes/defines.php';
}

require_once JPATH_BASE . '/includes/framework.php';
JDEBUG ? $_PROFILER->mark('afterLoad') : null;

// Instantiate the application.
$app = JFactory::getApplication('site');
error_reporting(E_ALL);
ini_set('display_errors', '1');
ini_set('memory_limit', '1024M');
ini_set('max_execution_time', 3000);

/* The following function gets all the images in a directory. */
function getAllImagesInDirectory($imagePath){
	$arrFilesDirectories = scandir($imagePath); 
	$arrFiles = array(); 
	foreach($arrFilesDirectories as $fileDirectory){
		if(is_file($imagePath.$fileDirectory))
			if (stripos($imagePath.$fileDirectory, '.jpg') || stripos($imagePath.$fileDirectory, '.png') || stripos($imagePath.$fileDirectory, '.gif'))
				$arrFiles[] = $fileDirectory;
				if (strpos($fileDirectory, ' ') !== FALSE) //handle images with spaces
					$arrFiles[] = str_replace(' ', '%20', $fileDirectory);
		
	}
	return $arrFiles;
}

/* The following function will get the new image path based on the image timestamp. The function will automatically create the directory if it doesn't already exist.*/
function getNewImagePath($imagePath, $imageFile){
	$imageFile = str_replace('%20', ' ', $imageFile);
	$year = date ("Y", filemtime($imagePath.$imageFile));
	$month= date ("m", filemtime($imagePath.$imageFile));
	if (!file_exists($imagePath.$year."-images/"))
		mkdir($imagePath.$year."-images/");
	if (!file_exists($imagePath.$year."-images/".$month))
		mkdir($imagePath.$year."-images/".$month);
	return $year."-images/".$month."/".$imageFile;
}

/* The following function will move the image from the old, unorganized location to the new, organized (categorized) location.*/
function moveImagetoRightLocation($imagePath, $imageFile, $newImageFile){
	rename($imagePath.$imageFile, $imagePath.$newImageFile);
}

/* The following function will replace old images with new images in Joomla's core content. */
function updateImagePathinArticle($arrOldImages, $arrNewImages){
	$db = JFactory::getDbo();
	$sql = "SELECT `id`, `introtext`, `fulltext` FROM #__content ORDER BY id ASC LIMIT 0, 10000";
	$db->setQuery($sql);
	$arrResult = $db->loadAssocList();
	for ($i = 0; $i < count($arrResult); $i++){
		for ($j = 0; $j < count($arrOldImages); $j++){
			if (strpos($arrResult[$i]['introtext'], 'images/'.$arrOldImages[$j]) || strpos($arrResult[$i]['fulltext'], 'images/'.$arrOldImages[$j])){
				$sql = "UPDATE #__content SET `introtext`=REPLACE(`introtext`, 'images/".$arrOldImages[$j]."', 'images/".$arrNewImages[$j]."'), `fulltext`=REPLACE(`fulltext`, 'images/".$arrOldImages[$j]."', 'images/".$arrNewImages[$j]."') WHERE id='".$arrResult[$i]['id']."';";
				echo($sql.'<br />');
				$db->setQuery($sql);
				$db->query();
			}
		}
	}
}

/* The following function will replace old images with new images in K2's content. */
function updateImagePathInK2Article($arrOldImages, $arrNewImages){
	$db = JFactory::getDbo();
	$sql = "SELECT `id`, `introtext`, `fulltext` FROM #__k2_items ORDER BY id ASC LIMIT 0, 10000";
	$db->setQuery($sql);
	$arrResult = $db->loadAssocList();
	for ($i = 0; $i < count($arrResult); $i++){
		for ($j = 0; $j < count($arrOldImages); $j++){
			if (strpos($arrResult[$i]['introtext'], 'images/'.$arrOldImages[$j]) || strpos($arrResult[$i]['fulltext'], 'images/'.$arrOldImages[$j])){
				$sql = "UPDATE #__k2_items SET `introtext`=REPLACE(`introtext`, 'images/".$arrOldImages[$j]."', 'images/".$arrNewImages[$j]."'), `fulltext`=REPLACE(`fulltext`, 'images/".$arrOldImages[$j]."', 'images/".$arrNewImages[$j]."') WHERE id='".$arrResult[$i]['id']."';";
				echo($sql.'<br />');
				$db->setQuery($sql);
				$db->query();
			}
		}
	}
}

/* The following function does all the work: It calls the other functions to move all the images from the "images" folder to their appropriate folders. */
function executeImageMove($imagePath){
	//check for trailing slash
	if (substr($imagePath, -1) != '/')
		$imagePath = $imagePath.'/';
	//check if path exists
	if (!file_exists($imagePath))
		die('This path does not exist on the server.');
	//get all the images under the main "images" folder
	$arrOldImages = getAllImagesInDirectory($imagePath);
	$arrNewImages = array();
	for ($i =0; $i < count($arrOldImages); $i++){
		//first get the new image path
		$newImageFile = getNewImagePath($imagePath, $arrOldImages[$i]);
		$arrNewImages[$i] = $newImageFile;
	}
	updateImagePathinArticle($arrOldImages, $arrNewImages);
	
	for ($i =0; $i < count($arrOldImages); $i++){
		moveImagetoRightLocation($imagePath, $arrOldImages[$i], $arrNewImages[$i]);
	}
	die('done...');
}

//The following path should be replaced with the absolute location of the images folder of your website.
executeImageMove('/home/[user]/public_html/images/');